﻿
namespace CSSCustomerEdit.Web.Services
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Data;
    using System.Linq;
    using System.ServiceModel.DomainServices.EntityFramework;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;
    using CSSModel;


    // Implements application logic using the CSSModelContainer context.
    // TODO: Add your application logic to these methods or in additional methods.
    // TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
    // Also consider adding roles to restrict access as appropriate.
    // [RequiresAuthentication]
    [EnableClientAccess()]
    public class CSSDomainService : LinqToEntitiesDomainService<CSSModelContainer>
    {

        private int myCompany = 1; // TODO: set myCompany during authentication
        public Company GetMyCompany()
        {
            return this.ObjectContext.Companies.Single(c=>c.Id.Equals(myCompany));
        }

        public void UpdateCompany(Company currentCompany)
        {
            // TODO: ensure user only edits authorized companies
            this.ObjectContext.Companies.AttachAsModified(currentCompany, this.ChangeSet.GetOriginal(currentCompany));
        }

        public IQueryable<Story> GetMyStories()
        {
            return this.ObjectContext.Stories.Where(s => s.CompanyId.Equals(myCompany));
        }

        public void InsertStory(Story story)
        {
            story.CompanyId = myCompany;
            story.Id = -1; // database will replace with next auto-increment value
            if ((story.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(story, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Stories.AddObject(story);
            }
        }

        public void UpdateStory(Story currentStory)
        {
            // TODO: ensure user only edits authorized stories
            this.ObjectContext.Stories.AttachAsModified(currentStory, this.ChangeSet.GetOriginal(currentStory));
        }

        public void DeleteStory(Story story)
        {
            // TODO: ensure user only deletes authorized stories
            if ((story.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Stories.Attach(story);
            }
            this.ObjectContext.Stories.DeleteObject(story);
        }
    }
}


